# If you assign a task to the same stage, they'll run in parallel
stages:
    - smoke_test
    - prepare_release
    - release


benchmarking:
    image: registry.gitlab.com/incoresemi/dockers/docker-chromite
    stage: smoke_test
    before_script:
      - |
        echo "
        machine gitlab.com
        login gitlab-ci-token
        password $CI_JOB_TOKEN
        " > ~/.netrc 
    script:
        - export PATH=$PATH:/incspike/bin
        - pip3 install -r requirements.txt
        - echo -e "section_start:`date +%s`:compile_rv64imacsu\r\e[0KDHRYSTONE- HW- RV64IMACSU\n"
        - python3 -m configure.main -ispec sample_config/rv64imacsu/isa.yaml -customspec sample_config/rv64imacsu/custom.yaml -cspec sample_config/rv64imacsu/core.yaml -gspec sample_config/rv64imacsu/csr_grouping.yaml -dspec sample_config/rv64imacsu/debug.yaml
        - make -j$(nproc) generate_verilog; make link_verilator_elf generate_boot_files
        - cd bin && ln -s ../benchmarks/output/code.mem . && cd ../
        - echo "DHRYSTONE HW-RV64IMACSU SW-RV64IMC\n" > dhrystone_numbers.txt
        - riscv64-unknown-elf-gcc --version >> dhrystone_numbers.txt
        - cd benchmarks && make dhrystone ITERATIONS=10000 march=rv64imc && cd ../
        - cd bin && ./chromite_core +elf=../benchmarks/output/dhry.riscv && cat app_log >> ../dhrystone_numbers.txt && cd ../
        - echo "DHRYSTONE HW-RV64IMACSU SW-RV64IM\n" >> dhrystone_numbers.txt
        - cd benchmarks && make dhrystone ITERATIONS=10000 march=rv64im && cd ../
        - cd bin && ./chromite_core +elf=../benchmarks/output/dhry.riscv && cat app_log >> ../dhrystone_numbers.txt && cd ../
        - echo -e "section_end:`date +%s`:compile_xlen32\r\e[0Ksection_start:`date +%s`:compile_rv64imasu\r\e[0KDHRYSTONE HW-RV64IMASU"
        - python3 -m configure.main -ispec sample_config/rv64imasu/isa.yaml -customspec sample_config/rv64imasu/custom.yaml -cspec sample_config/rv64imasu/core.yaml -gspec sample_config/rv64imasu/csr_grouping.yaml -dspec sample_config/rv64imasu/debug.yaml --clean
        - python3 -m configure.main -ispec sample_config/rv64imasu/isa.yaml -customspec sample_config/rv64imasu/custom.yaml -cspec sample_config/rv64imasu/core.yaml -gspec sample_config/rv64imasu/csr_grouping.yaml -dspec sample_config/rv64imasu/debug.yaml
        - make -j$(nproc) generate_verilog; make link_verilator_elf generate_boot_files
        - cd bin && ln -s ../benchmarks/output/code.mem . && cd ../
        - echo "DHRYSTONE HW-RV64IMASU SW-RV64IM\n" >> dhrystone_numbers.txt
        - cd benchmarks && make dhrystone ITERATIONS=10000 march=rv64im && cd ../
        - cd bin && ./chromite_core +elf=../benchmarks/output/dhry.riscv && cat app_log >> ../dhrystone_numbers.txt && cd ../
        - cat dhrystone_numbers.txt
        - make clean
        - rm -rf build bin
    only:
        - merge_requests
    tags:
      - inc_mas_server1

smoke-uatg-tests:
    image: registry.gitlab.com/incoresemi/dockers/docker-chromite
    stage: smoke_test
    before_script:
      - |
        echo "
        machine gitlab.com
        login gitlab-ci-token
        password $CI_JOB_TOKEN
        " > ~/.netrc 
    script:
        - export PATH=$PATH:/incspike/bin
        - pip3 install -r requirements.txt
        - echo -e "section_start:`date +%s`:check_rv64imacsu\r\e[0KTEST RV64IMACSU CONFIG"
        - python3 -m configure.main -ispec sample_config/rv64imacsu/isa.yaml -customspec sample_config/rv64imacsu/custom.yaml -cspec sample_config/rv64imacsu/core.yaml -gspec sample_config/rv64imacsu/csr_grouping.yaml -dspec sample_config/rv64imacsu/debug.yaml
        - make -j$(nproc) generate_verilog; make generate_boot_files
        - cd ci
        - pip3 install -r requirements.txt
        - git clone https://github.com/incoresemi/river_core_plugins.git
        - git clone https://github.com/incoresemi/chromite_uatg_tests.git -b dev
        - river_core generate -c rv64imacsu/river-config-uatg.ini
        - river_core compile -c rv64imacsu/river-config-uatg.ini -t mywork/test_list.yaml
        - mv mywork/reports ./reports_uatg_rv64imacsu
        - rm -rf mywork
    only:
        - master
        - merge_requests
    when: manual
        

smoke-riscof-tests:
    image: registry.gitlab.com/incoresemi/dockers/docker-chromite
    stage: smoke_test
    before_script:
      - |
        echo "
        machine gitlab.com
        login gitlab-ci-token
        password $CI_JOB_TOKEN
        " > ~/.netrc 
    script:
        - export PATH=$PATH:/incspike/bin
        - pip3 install -r requirements.txt
        - echo -e "section_start:`date +%s`:check_rv64imacsu\r\e[0KTEST RV64IMAFDCSU CONFIG"
        - python3 -m configure.main -ispec sample_config/rv64imacsu/isa.yaml -customspec sample_config/rv64imacsu/custom.yaml -cspec sample_config/rv64imacsu/core.yaml -gspec sample_config/rv64imacsu/csr_grouping.yaml -dspec sample_config/rv64imacsu/debug.yaml
        - make -j$(nproc) generate_verilog; make generate_boot_files
        - cd ci
        - pip3 install -r requirements.txt
        - git clone https://github.com/incoresemi/river_core_plugins.git
        - git clone https://gitlab.com/incoresemi/riscof-plugins.git
        - river_core generate -c rv64imacsu/river-config-riscof.ini
        - river_core compile -c rv64imacsu/river-config-riscof.ini -t mywork/test_list.yaml
        - mv mywork/reports ./reports_riscvtests_rv64imacsu
        - rm -rf mywork
        - echo -e "section_end:`date +%s`:check_rv64imacsu\r\e[0Ksection_start:`date +%s`:check_rv32imafcsu\r\e[0KTEST RV32IMAFCSU CONFIG"
    only:
        - merge_requests
    tags:
      - inc_mas_server1

smoke-torture-tests:
    image: registry.gitlab.com/incoresemi/dockers/docker-chromite
    stage: smoke_test
    before_script:
      - |
        echo "
        machine gitlab.com
        login gitlab-ci-token
        password $CI_JOB_TOKEN
        " > ~/.netrc 
    script:
        - export PATH=$PATH:/incspike/bin
        - pip3 install -r requirements.txt
        - echo -e "section_start:`date +%s`:check_rv64imacsu\r\e[0KTEST RV64IMAFDCSU CONFIG"
        - python3 -m configure.main -ispec sample_config/rv64imacsu/isa.yaml -customspec sample_config/rv64imacsu/custom.yaml -cspec sample_config/rv64imacsu/core.yaml -gspec sample_config/rv64imacsu/csr_grouping.yaml -dspec sample_config/rv64imacsu/debug.yaml
        - make -j$(nproc) generate_verilog; make generate_boot_files
        - cd ci
        - pip3 install -r requirements.txt
        - git clone https://github.com/incoresemi/river_core_plugins.git
        - river_core generate -c rv64imacsu/river-config-riscvtorture.ini
        - river_core compile -c rv64imacsu/river-config-riscvtorture.ini -t mywork/test_list.yaml
        - mv mywork/reports ./reports_riscvtorture_rv64imacsu
        - rm -rf mywork
        - echo -e "section_end:`date +%s`:check_rv64imacsu\r\e[0Ksection_start:`date +%s`:check_rv32imafcsu\r\e[0KTEST RV32IMAFCSU CONFIG"
    only:
        - merge_requests
    tags:
      - inc_mas_server1

smoke-riscv-tests:
    image: registry.gitlab.com/incoresemi/dockers/docker-chromite
    stage: smoke_test
    before_script:
      - |
        echo "
        machine gitlab.com
        login gitlab-ci-token
        password $CI_JOB_TOKEN
        " > ~/.netrc 
    script:
        - export PATH=$PATH:/incspike/bin
        - pip3 install -r requirements.txt
        - echo -e "section_start:`date +%s`:check_rv64imacsu\r\e[0KTEST RV64IMAFDCSU CONFIG"
        - python3 -m configure.main -ispec sample_config/rv64imacsu/isa.yaml -customspec sample_config/rv64imacsu/custom.yaml -cspec sample_config/rv64imacsu/core.yaml -gspec sample_config/rv64imacsu/csr_grouping.yaml -dspec sample_config/rv64imacsu/debug.yaml
        - make -j$(nproc) generate_verilog; make generate_boot_files
        - cd ci
        - pip3 install -r requirements.txt
        - git clone https://github.com/incoresemi/river_core_plugins.git
        - git clone https://github.com/incoresemi/chromite_uatg_tests.git -b dev
        - river_core generate -c rv64imacsu/river-config-riscvtests.ini
        - river_core compile -c rv64imacsu/river-config-riscvtests.ini -t mywork/test_list.yaml
        - mv mywork/reports ./reports_riscvtests_rv64imacsu
        - rm -rf mywork
        - echo -e "section_end:`date +%s`:check_rv64imacsu\r\e[0Ksection_start:`date +%s`:check_rv32imafcsu\r\e[0KTEST RV32IMAFCSU CONFIG"
        - cd ..
        - python3 -m configure.main -ispec sample_config/rv32imafcsu/isa.yaml -customspec sample_config/rv32imafcsu/custom.yaml -cspec sample_config/rv32imafcsu/core.yaml -gspec sample_config/rv32imafcsu/csr_grouping.yaml -dspec sample_config/rv32imafcsu/debug.yaml --clean
        - python3 -m configure.main -ispec sample_config/rv32imafcsu/isa.yaml -customspec sample_config/rv32imafcsu/custom.yaml -cspec sample_config/rv32imafcsu/core.yaml -gspec sample_config/rv32imafcsu/csr_grouping.yaml -dspec sample_config/rv32imafcsu/debug.yaml
        - make -j$(nproc) generate_verilog; make generate_boot_files
        - cd ci
        - river_core generate -c rv32imafcsu/river-config-riscvtests.ini
        - river_core compile -c rv32imafcsu/river-config-riscvtests.ini -t mywork/test_list.yaml
        - mv mywork/reports ./reports_riscvtests_rv32imafcsu
        - rm -rf mywork
    only:
        - merge_requests
    tags:
      - inc_mas_server1

# checks if the changelog has been updated and the version has also been upgraded
check-mr-compliance:
    stage: prepare_release
    image: registry.gitlab.com/incoresemi/dockers/docker-bsc
    rules:
      - if: $CI_COMMIT_TAG
        when: never                                             # Do not run this job when a tag is created manually
      - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH             # Run this job when commits are pushed or merged to the default branch
      - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
        when: always
    script:
        - export NEWVER=$(grep -P "^\[.*?\]" CHANGELOG.rst -m1 | awk '{print $1}' | sed 's/[][]//g');
        - export CURVER=$(git describe --tags| cut -f1 -d"-")
        - echo $NEWVER
        - echo $CURVER        
        - echo "TAG=$(grep -P "^\[.*?\]" CHANGELOG.rst -m1 | awk '{print $1}' | sed 's/[][]//g')" >> variables.env
        - cat variables.env
        - CURVER=${CURVER//./ }
        - NEWVER=${NEWVER//./ }
        - curpatch=$(echo $CURVER | awk '{print $3}')
        - curminor=$(echo $CURVER | awk '{print $2}')
        - curmajor=$(echo $CURVER | awk '{print $1}')
        - newpatch=$(echo $NEWVER | awk '{print $3}')
        - newminor=$(echo $NEWVER | awk '{print $2}')
        - newmajor=$(echo $NEWVER | awk '{print $1}')
        - if [ $newmajor = $curmajor ] && [ $newminor = $curminor ] && [ $newpatch -gt $curpatch ]; then echo "Patch Update Accepted OK"; exit 0; fi
        - if [ $newmajor = $curmajor ] && [ $newminor = $curminor ] && [ $newpatch -le $curpatch ]; then echo "Revise Patch Atleast!"; exit 1; fi
        - if [ $newmajor = $curmajor ] && [ $newminor -gt $curminor ] && [ $newpatch = 0 ]; then echo "Minor Update Accepted OK!"; exit 0; fi
        - if [ $newmajor = $curmajor ] && [ $newminor -gt $curminor ] && [ $newpatch != 0 ]; then echo "For Minor changes the patches should be 0"; exit 1; fi
        - if [ $newmajor = $curmajor ] && [ $newminor -lt $curminor ]; then echo "Minor version should greater than previuos"; exit 1; fi
        - if [ $newmajor -gt $curmajor ] && [ $newminor = 0 ] && [ $newpatch = 0 ]; then echo "Major Updated Accepted OK"; exit 0; fi
        - echo  "For Major updates Minor and Patches should be 0"
        - exit 1
    artifacts:
      reports:
        dotenv: variables.env                                   # Use artifacts:reports:dotenv to expose the variables to other jobs

release_job:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  needs:
    - job: check-mr-compliance
      artifacts: true
  rules:
    - if: $CI_COMMIT_TAG
      when: never                                  # Do not run this job when a tag is created manually
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH  # Run this job when commits are pushed or merged to the default branch
  script:
    - echo "running release_job for $TAG"
    - CHANGELOG_START=`awk '/\[/{print NR+2; exit;}' CHANGELOG.rst`
    - CHANGELOG_END=`awk '/\[/{ count++; if(count>1) {print NR-1; exit;}}' CHANGELOG.rst`
    - EXTRA_DESCRIPTION=`awk 'NR > '$CHANGELOG_START' && NR < '$CHANGELOG_END' ' CHANGELOG.rst`
  release:
    name: 'Release $TAG'
    description: 'Created using the release-cli $EXTRA_DESCRIPTION'  # $EXTRA_DESCRIPTION and the $TAG
    tag_name: '$TAG'                                                 # variables must be defined elsewhere
    ref: '$CI_COMMIT_SHA'                                            # in the pipeline. For example, in the

